/*
 * Copyright (c) University of Toronto 1985, 1986, 1987, 1988, 1989, 1990.
 * All rights reserved.
 * Written mostly by Geoffrey Collyer and Henry Spencer.
 * This software is not subject to any license of the American Telephone
 * and Telegraph Company or of the Regents of the University of California.
 *
 * Permission is granted to anyone to use this software for any purpose on
 * any computer system, and to alter it and redistribute it freely, subject
 * to the following restrictions:
 *
 * 1. The authors are not responsible for the consequences of use of this
 *    software, no matter how awful, even if they arise from flaws in it.
 *
 * 2. The origin of this software must not be misrepresented, either by
 *    explicit claim or by omission.  Since few users ever read sources,
 *    credits must appear in the documentation.
 *
 * 3. Altered versions must be plainly marked as such, and must not be
 *    misrepresented as being the original software.  Since few users
 *    ever read sources, credits must appear in the documentation.
 *
 * 4. This notice may not be removed or altered.
 */

/*
 * error - print best error message possible and exit
 */

#include <stdio.h>

/*
 * warning - print best error message possible and clear errno
 */

void
warning(s1, s2)
char *s1;
char *s2;
{
	char *cmdname;
	int saverrno;
	extern int errno, sys_nerr;
	extern char *sys_errlist[];
	extern char *progname;
	extern char *getenv();

	saverrno = errno;		/* so isatty(3) won't clobber it */
	(void) fflush(stdout);				/* hack */
	cmdname = getenv("CMDNAME");
	if (cmdname != NULL && *cmdname != '\0')
		fprintf(stderr, "%s:", cmdname);	/* No space after :. */
	if (progname != NULL)
		fprintf(stderr, "%s: ", progname);
	fprintf(stderr, s1, s2);
	if (saverrno > 0 && saverrno < sys_nerr)
		fprintf(stderr, " (%s)", sys_errlist[saverrno]);
	fprintf(stderr, "\n");
	errno = 0;
}

void
error(s1, s2)
char *s1;
char *s2;
{
	warning(s1, s2);
	exit(1);
}

